Package: groovy.jmx.builder

## [Groovy] Class JmxBuilder

- groovy.jmx.builder.JmxBuilder

-     class JmxBuilder
      extends FactoryBuilderSupport

  This is JmxBuilder's factory builder class. It is the parent node to all other children nodes supported by JmxBuilder.

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class FactoryBuilderSupport` | `CHILD_BUILDER, CURRENT_BUILDER, CURRENT_FACTORY, CURRENT_NAME, CURRENT_NODE, OWNER, PARENT_BUILDER, PARENT_CONTEXT, PARENT_FACTORY, PARENT_NAME, PARENT_NODE, SCRIPT_CLASS_NAME, attributeDelegates, autoRegistrationComplete, autoRegistrationRunning, explicitMethods, explicitProperties, methodMissingDelegate, postInstantiateDelegates, postNodeCompletionDelegates, preInstantiateDelegates, propertyMissingDelegate, registrationGroup, registrationGroupName`

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `String` | `defaultJmxNameDomain`
    `String` | `defaultJmxNameType`
    `MBeanServerConnection` | `mBeanServer`
    `String` | `mode`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `JmxBuilder()` Creates a builder backed by the default MBean server connection.
    `JmxBuilder(MBeanServerConnection svrConnection)` Creates a builder backed by the supplied MBean server connection.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `String` | `getDefaultJmxNameDomain()` Returns the default domain used when generating object names.
    `` | `String` | `getDefaultJmxNameType()` Returns the default type used when generating object names.
    `` | `MBeanServerConnection` | `getMBeanServer()` Returns the active MBean server connection, creating the default one on demand.
    `` | `String` | `getMode()` Returns the current builder mode.
    `` | `protected void` | `registerFactories()` Registers the builder nodes supported by `JmxBuilder`.
    `` | `protected Factory` | `resolveFactory(Object name, Map attributes, Object value)` Resolves a factory for the requested node, falling back to the parent factory when needed.
    `` | `void` | `setDefaultJmxNameDomain(String domain)` Sets the default domain used when generating object names.
    `` | `void` | `setDefaultJmxNameType(String type)` Sets the default type used when generating object names.
    `` | `void` | `setMBeanServer(MBeanServerConnection svr)` Replaces the active MBean server connection.
    `` | `void` | `setMode(String mode)` Sets the builder mode.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class FactoryBuilderSupport` | `addAttributeDelegate, addDisposalClosure, addPostInstantiateDelegate, addPostNodeCompletionDelegate, addPreInstantiateDelegate, autoRegisterNodes, build, build, build, checkExplicitMethod, checkValueIsNull, checkValueIsType, checkValueIsTypeNotString, createNode, dispatchNodeCall, dispathNodeCall, dispose, getAttributeDelegates, getChildBuilder, getContext, getContextAttribute, getContexts, getContinuationData, getCurrent, getCurrentBuilder, getCurrentFactory, getCurrentName, getDisposalClosures, getExplicitMethods, getExplicitProperties, getFactories, getLocalExplicitMethods, getLocalExplicitProperties, getLocalFactories, getMethodMissingDelegate, getName, getNameMappingClosure, getParentContext, getParentFactory, getParentName, getParentNode, getPostInstantiateDelegates, getPostNodeCompletionDelegates, getPreInstantiateDelegates, getProperty, getPropertyMissingDelegate, getProxyBuilder, getRegistrationGroupItems, getRegistrationGroups, getVariable, getVariables, handleNodeAttributes, invokeMethod, invokeMethod, newContext, nodeCompleted, popContext, postInstantiate, postNodeCompletion, preInstantiate, registerBeanFactory, registerBeanFactory, registerExplicitMethod, registerExplicitMethod, registerExplicitProperty, registerExplicitProperty, registerFactory, registerFactory, removeAttributeDelegate, removePostInstantiateDelegate, removePostNodeCompletionDelegate, removePreInstantiateDelegate, reset, resolveExplicitMethod, resolveExplicitProperty, resolveFactory, restoreFromContinuationData, setClosureDelegate, setMethodMissingDelegate, setNameMappingClosure, setNodeAttributes, setParent, setProperty, setPropertyMissingDelegate, setProxyBuilder, setVariable, withBuilder, withBuilder, withBuilder`
    `class Binding` | `getProperty, getVariable, getVariables, hasVariable, removeVariable, setProperty, setVariable`
    `class GroovyObjectSupport` | `getMetaClass, setMetaClass`

- - ### Property Detail

    - #### String defaultJmxNameDomain

    - #### String defaultJmxNameType

    - #### MBeanServerConnection mBeanServer

    - #### String mode

  - ### Constructor Detail

    - #### JmxBuilder()

      Creates a builder backed by the default MBean server connection.

    - #### JmxBuilder(MBeanServerConnection svrConnection)

      Creates a builder backed by the supplied MBean server connection.

      Parameters:
        `svrConnection` - the server connection to use

  - ### Method Detail

    - #### String getDefaultJmxNameDomain()

      Returns the default domain used when generating object names.

      Returns:
        the default JMX domain

    - #### String getDefaultJmxNameType()

      Returns the default type used when generating object names.

      Returns:
        the default JMX type

    - #### MBeanServerConnection getMBeanServer()

      Returns the active MBean server connection, creating the default one on demand.

      Returns:
        the active server connection

    - #### String getMode()

      Returns the current builder mode.

      Returns:
        the builder mode

    - #### protected void registerFactories()

      Registers the builder nodes supported by `JmxBuilder`.

    - #### protected Factory resolveFactory(Object name, Map attributes, Object value)

      Resolves a factory for the requested node, falling back to the parent factory when needed.

      Parameters:
        `name` - the node name
        `attributes` - the node attributes
        `value` - the node value
      Returns:
        the resolved factory, if any

    - #### void setDefaultJmxNameDomain(String domain)

      Sets the default domain used when generating object names.

      Parameters:
        `domain` - the default JMX domain

    - #### void setDefaultJmxNameType(String type)

      Sets the default type used when generating object names.

      Parameters:
        `type` - the default JMX type

    - #### void setMBeanServer(MBeanServerConnection svr)

      Replaces the active MBean server connection.

      Parameters:
        `svr` - the server connection to use

    - #### void setMode(String mode)

      Sets the builder mode.

      Parameters:
        `mode` - the builder mode